#!/usr/bin/env perl

use strict;
use warnings;
use Cwd;

#TODO check isystem file exists

sub pathback{
	my ($path) = @_;
	$path =~ s/(.*)\/.*$/$1/;
	return $path ne '' ? $path : undef;
}

sub pathNormalize{
	my ($path) = @_;
	my $loc = getcwd();
	my $bk = pathback($loc);
	my $home = $ENV{HOME};
	$path =~ s/^\~/$home/;
	$path =~ s/\.\.\//$bk\// if defined $bk;
	$path =~ s/\.\//$loc\// if defined $loc;
	return $path;
}

sub fdToLine {
	my ($fd, $pattern) = @_;
	while ( my $line = <$fd> ) {
		#print "SKIP:$line" unless $line =~ /$pattern/;
		return $line if $line =~ /$pattern/;
	}
	return '';
}

sub parseFlags {
	my ($line) = @_;
	#print "SKIP:$line" if $line =~ /^[ \t]*\#/;
	return if $line =~ /^[ \t]*\#/;
	#print "PARSE:$line";
	my @fl = $line =~ /\'([a-zA-Z0-9_\/=.-]*)\'/g;
	#print "NO ELEMENT\n" if scalar @fl == 0;
	return @fl;
}

sub flagsTrans{
	my ($flag) = @_;
	return if $flag eq 'c' or $flag eq 'c++';
	return '-I' if $flag eq '-isystem';
	return $flag;
}

my $defycm = '~/.vim/.ycm_extra_conf.py' if $ARGV[0] eq 'default';
my $fnycm = pathNormalize($defycm);
my $flags = '';

open my $fd, '<', $fnycm or die "error on open $fnycm\ncause: $!";

my $flagsLine = fdToLine($fd, 'flags = \[');
die 'error on search flags line' if $flagsLine eq '';

my @allflags;
my @inflags = parseFlags($flagsLine);
if ( scalar @inflags ) {
	map { 
		my $nw;
		push @allflags, $nw if $nw = flagsTrans($_); 
	} @inflags;
}

while ( $flagsLine = <$fd> ) {
	@inflags = parseFlags($flagsLine);
	if ( scalar @inflags ) {
		map { 
			my $nw;
			push @allflags, $nw if $nw = flagsTrans($_); 
		} @inflags;
	}
	last if $flagsLine =~ /\]/;
}

map { print "$_ "; } @allflags;







